!define PRODUCT_NAME        "Vacuum-Music.com Button"
!define PRODUCT_VERSION     "1.0"
!define PRODUCT_PUBLISHER   "Vacuum-Music.com"
!define PRODUCT_WEB_SITE    "http://vacuum-music.com"
!define PRODUCT_UNINST_KEY  "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define IE_EXTENTIONS_KEY   "Software\Microsoft\Internet Explorer\Extensions\"

ChangeUI           all "${NSISDIR}\Contrib\UIs\sdbarker_tiny.exe"
WindowIcon         off
Name               "${PRODUCT_NAME}"
OutFile            "vmb_setup.exe"
InstallDir         "$PROGRAMFILES\VMButton"
Icon               "vmb_setup.ico"
UninstallIcon      "vmb_setup.ico"
DirText            "Setup will install $(^Name) in the following folder.$\r$\nTo install in a different folder, click Browse and select another folder."
ShowInstDetails    show
ShowUnInstDetails  show
InstProgressFlags  smooth

Page directory CheckVMButtonExistence
Page instfiles ConfirmInstall

Section Install
  SetOutPath "$INSTDIR"
  File "vmbhicon.ico"
  File "vmbicon.ico"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  Call CreateGUID
  Pop $0
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "CLSID" "$0"
  WriteRegStr HKCU "${IE_EXTENTIONS_KEY}$0" "ButtonText" "${PRODUCT_PUBLISHER}"
  WriteRegStr HKCU "${IE_EXTENTIONS_KEY}$0" "CLSID" "{1FBA04EE-3024-11d2-8F1F-0000F87ABD16}"
  WriteRegStr HKCU "${IE_EXTENTIONS_KEY}$0" "Default Visible" "Yes"
  WriteRegStr HKCU "${IE_EXTENTIONS_KEY}$0" "Exec" "http://www.vacuum-music.com"
  WriteRegStr HKCU "${IE_EXTENTIONS_KEY}$0" "HotIcon" "$INSTDIR\vmbhicon.ico"
  WriteRegStr HKCU "${IE_EXTENTIONS_KEY}$0" "Icon" "$INSTDIR\vmbicon.ico"
  DeleteRegKey HKCU "Software\Microsoft\Internet Explorer\Toolbar\{1E796980-9CC5-11D1-A83F-00C04FC99D61}"
  WriteUninstaller "$INSTDIR\uninst.exe"
SectionEnd

Section Uninstall
  SetAutoClose true
  ReadRegStr $0 HKLM "${PRODUCT_UNINST_KEY}" "CLSID"
  DeleteRegKey HKCU "${IE_EXTENTIONS_KEY}$0"
  DeleteRegKey HKCU "Software\Microsoft\Internet Explorer\Toolbar\{1E796980-9CC5-11D1-A83F-00C04FC99D61}"
  DeleteRegKey HKLM "${PRODUCT_UNINST_KEY}"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\vmbicon.ico"
  Delete "$INSTDIR\vmbhicon.ico"
  RMDir "$INSTDIR"
SectionEnd

Function ConfirmInstall
  MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2 "   This will install $(^Name)$\r$\nonto your Internet Explorer standard toolbar.$\r$\n$\r$\n   Note: Your Internet Explorer standard toolbar$\r$\nsettings will be reset to its defaults.$\r$\n$\r$\n   Would you like to continue?" IDYES +2
  Quit
FunctionEnd

Function CreateGUID
  Push $2
  Push $1
  Push $0
  System::Alloc 80
  System::Alloc 16
  System::Call 'ole32::CoCreateGuid(i sr0) i'
  System::Call 'ole32::StringFromGUID2(i r0, i sr1, i 80) i'
  System::Call 'kernel32::WideCharToMultiByte(i 0, i 0, i r1, i 80, t .r2, i ${NSIS_MAX_STRLEN}, i 0, i 0) i'
  System::Free $0
  System::Free $1
  Pop $0
  Pop $1
  Exch $2
FunctionEnd

Function CheckVMButtonExistence
  ReadRegStr $0 HKLM "${PRODUCT_UNINST_KEY}" "CLSID"
  StrCmp $0 "" +4
  HideWindow
  MessageBox MB_OK|MB_ICONEXCLAMATION  "$(^Name) is already installed!"
  Quit
FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2 "   Would you like to uninstall $(^Name)$\r$\nfrom your Internet Explorer standard toolbar?$\r$\n$\r$\n   Note: Your Internet Explorer standard toolbar settings$\r$\nwill be reset to its defaults.$\r$\n$\r$\n   Would you like to continue?" IDYES +2
  Abort
FunctionEnd
